s         ::=  grammar ws                  => "gram"
ws       !::=  w** | w** "//" (~[\n]*) "\n" ws
wp       !::=  w++
grammar   ::=  r +/ ws                        => "grammar"

r         ::=  word  ^"::=" alternatives /ws
            |  word ^"!::=" alternatives /ws

alternatives  ::=  (conjuncts +/ (ws "|" ws)) +/ (ws ">" ws)

conjuncts     ::=  sequence
                |  sequence ^"&"  e*/ws   /ws
                |  sequence ^"&~" e*/ws   /ws

ps         ::= e*/ws                              => "ps"
             | (e+/ws ws)? "^" quoted (ws e+/ws)? => "ps2"
psy        ::= ps
             | ps wp ^"/" ws e
psx        ::= psy                   => "psy"
             | e "<-" psy        /ws => "psyl"
             |        psy "->" e /ws => "psyr"
             | e "<-" psy "->" e /ws => "psylr"
sequence   ::= quoted => "qprod"
             > psx
             | psx  "=>" ^"[]"         /ws
             | psx ^"=>" (word|quoted) /ws

ec       ::= ~[\-\]\\]
           | escaped

range    ::= ec          => "range"
           | ec ^"-" ec

e        ::=  word                          => "nonTerminal"
           |  quoted                        => "literal"
           |    ^"()"
           |    ^"{" sequence "}"       /ws
           |    ^"["  range* "]"

           |  (e ^"++"    /ws > e ^"+"    /ws)
           |  (e ^"++/" e /ws > e ^"+/" e /ws)
           |  (e ^"**"    /ws > e ^"*"    /ws)
           |  (e ^"**/" e /ws > e ^"*/" e /ws)
           |  e ^"?"                    /ws

           |     "(" word         ^")"  /ws
           >    ^"(" alternatives  ")"  /ws
           |    ^"~" e

w       !::= " "
           | "\n"
           | "\r"
word     ::= [a-zA-Z0-9_]++
quoted   ::= "\"" ((~[\"\\] | escaped)+) "\""
           | "\"\"" => ""
escaped  ::= "\\n" => "\n"
           | "\\r" => "\r"
           | "\\" ~[nr]


